State
Date: 2017-06-10

org.gcube.informationsystem.collector.impl.xmlstorage.exist

## Class State

- java.lang.Object
- - org.gcube.informationsystem.collector.impl.xmlstorage.exist.State

-     public class State
      extends java.lang.Object

  The global state of an IC instance
  Author:
    Manuele Simi (ISTI-CNR)

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.util.List<GCUBEXMLResource>` | `deletedResources` List of recently deleted resources.
    `static java.lang.Thread` | `schedulerT` Thread that periodically backups the XMLStorage
    `static java.lang.Thread` | `sweeperT` Thread that periodically sweeps the XMLStorage from expired resources

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `State()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `dispose()` Releases all the State resources
    `static DataManager` | `getDataManager()`
    `static java.util.List<GCUBEXMLResource>` | `getDeletedResources()`
    `static QueryManager` | `getQueryManager()`
    `static void` | `initialize()` Initializes the eXist DB connections using during the service life
    `void` | `printEnv()` Prints the enviromnet variables

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### sweeperT

          public static java.lang.Thread sweeperT

      Thread that periodically sweeps the XMLStorage from expired resources

    - #### schedulerT

          public static java.lang.Thread schedulerT

      Thread that periodically backups the XMLStorage

    - #### deletedResources

          public static java.util.List<GCUBEXMLResource> deletedResources

      List of recently deleted resources. It is used to avoid the storage of RPs of a deleted resource

  - ### Constructor Detail

    - #### State

          public State()

  - ### Method Detail

    - #### initialize

          public static void initialize()
                                 throws java.lang.Exception

      Initializes the eXist DB connections using during the service life
      Parameters:
        `configuration` - the RI configuration loaded from the JNDI resource
      Throws:
        `java.lang.Exception` - if the intialization fails

    - #### dispose

          public static void dispose()
                              throws java.lang.Exception

      Releases all the State resources
      Throws:
        `java.lang.Exception` - if the shutdown fails

    - #### getDataManager

          public static DataManager getDataManager()

      Returns:
        the dataManager

    - #### getQueryManager

          public static QueryManager getQueryManager()

      Returns:
        the queryManager

    - #### getDeletedResources

          public static java.util.List<GCUBEXMLResource> getDeletedResources()

      Returns:
        the deletedResources

    - #### printEnv

          public void printEnv()

      Prints the enviromnet variables